name: Build Ubuntu

on: [push]

jobs:
  ubuntu:
    name: Build & Test
    runs-on: ubuntu-22.04
    steps:
      - name: Checkout
        uses: actions/checkout@v3
      - name: Install deps
        run: sudo tools/debian-setup.sh --install-all python3-pip -y
      - name: Mkdir
        run: mkdir build
      - name: Cmake
        working-directory: build
        run: cmake -GNinja ..
      - name: Build
        run: ninja
        working-directory: build
      - name: Build test-programs
        run: ninja test-programs
        working-directory: build
      - name: Set up Python 3.8
        uses: actions/setup-python@v4
        with:
          python-version: 3.8
      - name: Install pytest
        run: pip install pytest pytest-xdist
      - name: Run tests
        env:
          PYTEST_ADDOPTS: --skip-missing-programs=rawshark
        run: pytest
        working-directory: build
      - name: Build debian pkg
        run: |
          ln --symbolic --no-dereference --force packaging/debian
          tools/make-version.py --set-release .
          export DEB_BUILD_OPTIONS="nocheck parallel=$(( $(getconf _NPROCESSORS_ONLN) + 2 ))"
          export DH_QUIET=1
          export MAKEFLAGS=--silent
          dpkg-buildpackage -b -us -uc -jauto
      - name: Move deb packages
        run: |
          mkdir deb
          mv ../*.deb deb
      - name: Upload deb packages
        uses: actions/upload-artifact@v3
        with:
          name: packages
          path: deb
